/* install openssh on OS/2, by kadzsol@xenia.sote.hu on 25.11.2003 */

Say 
Say 'This script will install ssh/sshd + some files of security/2 on your' 
Say 'system. The EMX runtime should be present for succesful installation.'
Say 'Press enter to continue or ctrl-c+enter to abort'
pull response
Say
Say 'Installing files...'

/* create config */
etc = value('ETC',,'os2environment')
'@mkdir 'etc'\SSH'
'@copy etc\ssh\* 'etc'\ssh\.'
'@copy term.cfg 'etc'\.'
Say
Say 'On which port would you like to run sshd? (press enter for default 22)'
pull port
if port = '' then port = 22
sshdcfg = etc'\ssh\sshd_config' 
'@copy 'sshdcfg' 'etc'\ssh\sshd_config.org' 
'@echo Port 'port' > 'sshdcfg
'@echo Protocol 2  >> 'sshdcfg
'@echo HostKey 'etc'\ssh\ssh_host_dsa_key >> 'sshdcfg
'@echo LoginGraceTime 300  >> 'sshdcfg
'@echo Banner 'etc'\ssh_banner.txt  >> 'sshdcfg
'@echo IgnoreUserKnownHosts yes  >> 'sshdcfg
'@echo PasswordAuthentication yes  >> 'sshdcfg
'@echo SyslogFacility AUTH >> 'sshdcfg
'@echo LogLevel INFO >> 'sshdcfg
'@echo PermitRootLogin yes >> 'sshdcfg
'@echo StrictModes yes >> 'sshdcfg
'@echo RSAAuthentication no >> 'sshdcfg
'@echo PubkeyAuthentication yes >> 'sshdcfg
'@echo AuthorizedKeysFile .ssh/authorized_keys >> 'sshdcfg
'@echo IgnoreRhosts yes >> 'sshdcfg
'@echo RhostsRSAAuthentication no >> 'sshdcfg
'@echo HostbasedAuthentication no >> 'sshdcfg
'@echo PermitEmptyPasswords no >> 'sshdcfg
'@echo ChallengeResponseAuthentication no >> 'sshdcfg
'@echo MaxStartups 10 >> 'sshdcfg
'@echo ClientAliveInterval 600 >> 'sshdcfg
'@echo ClientAliveCountMax 3 >> 'sshdcfg
mptnbin = translate(value('PATH',,'os2environment'))
mptnbin = substr(mptnbin, pos(':\MPTN\BIN',mptnbin)-1, 11)
'@echo Subsystem sftp 'mptnbin'\sftp-server.exe >> 'sshdcfg
'@echo Welcome to this secure OS/2 system >> 'etc'\ssh_banner.txt'

/* copy binaries */
'@copy *.exe 'mptnbin'\.'
mptndll = substr(mptnbin, 1, 8)'DLL'
'@copy *.dll 'mptndll'\.'

/* create homedir */
bdrv = translate(value('PATH',,'os2environment'))
bdrv = substr(bdrv, pos(':\OS2\SYSTEM',bdrv)-1, 3)
user = 'os2root'
home = bdrv'home\'user
'@mkdir 'bdrv'home >nul 2>>&1'
'@mkdir 'home' >nul 2>>&1'
'@mkdir 'home'\.ssh >nul 2>>&1'

/* copy/create sec/2 files */
'@copy sses.sys 'bdrv'os2\boot\.'
aclcfg = etc'\acls' 
'@echo [100:first] > 'aclcfg
'@echo * * >> 'aclcfg
'@echo cdrw ^<acl^> >> 'aclcfg
'@echo cdrwx ^<user^> >> 'aclcfg
'@echo x ^<dll^> >> 'aclcfg
'@echo+ >> 'aclcfg
'@echo [101:last] >> 'aclcfg
'@echo * * >> 'aclcfg
'@echo 'user':$1$K2hF$WwLkg9GMZjx3L814A4dPj/:0:0::$'space(translate(home,'',':'),0)':$'space(translate(mptnbin,'',':'),0)'\viostart.EXE:$'space(translate(mptnbin,'',':'),0)'\viostart.EXE: > 'etc'\passwd'

/* update config.sys */
cfgsys = bdrv'CONFIG.SYS'
'@copy 'cfgsys' 'bdrv'CONFIG.SSH'
'@echo BASEDEV=SSES.SYS /suanyuser >> 'cfgsys
'@echo RUN='mptnbin'\ssesctl.exe --source 'etc'\passwd?'etc'\acls --logfile 'bdrv'ssesctl.log >> 'cfgsys

/* create keys */
say
say 'Please type in a passphrase for the root user (press enter for none)'
pull phrase
say
say 'Generating user keys...'
'@'mptnbin'\ssh-keygen.exe -b 2048 -t dsa -f 'home'\.ssh\id_dsa -N "'phrase'"'
'@copy 'home'\.ssh\id_dsa.pub 'home'\.ssh\authorized_keys'
say
say 'Generating server keys...'
'@'mptnbin'\ssh-keygen.exe -b 2048 -t dsa -f 'etc'\ssh\ssh_host_dsa_key -N ""'

/* inform */
say
say 'Root user is os2root, pwd rootos2, see "user.exe -?" to change it.'
say 'Start ssh daemon with the command "start sshd"'
say 'Start ssh client with the command "ssh -l 'user' <your hostname>"'
say 
say 'Please, reboot you system now. Do not forget to read the docs!!!'

exit
